/*
 * Fachlicher Schlüssel für JPA Entität
 */
package de.ivu.elect.business.kandidatur.entity;

import de.ivu.elect.jee.faces.Messages;
import de.ivu.elect.jee.faces.IMessages;
import java.util.function.Function;

@javax.enterprise.inject.Vetoed
public class DirektkandidaturTK
extends de.ivu.elect.business.kandidatur.entity.KandidaturTK
  {

  private static final long serialVersionUID = 1L;

  private final int hashCode;

  protected final de.ivu.elect.business.wahlvorschlag.entity.DirektkandidatTK direktkandidatTK;
    public de.ivu.elect.business.wahlvorschlag.entity.DirektkandidatTK getDirektkandidatTK(){
      return direktkandidatTK;
    }

  public DirektkandidaturTK(
  de.ivu.elect.business.wahlvorschlag.entity.DirektkandidatTK direktkandidatTK
  ) {
super(



);


        this.direktkandidatTK = direktkandidatTK;
  
hashCode = calculateHashCode();
  }

  @Override
  public int hashCode(){
    return hashCode;
  }


  protected int calculateHashCode() {
        int result = super.calculateHashCode();
    
    
        
                    result = result + ((direktkandidatTK == null) ? 0 : direktkandidatTK.hashCode());
            
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }

    if (obj == null) {
      return false;
    }

    if (hashCode()!=obj.hashCode()) {
      return false;
    }


                    if (super.hatAttribute() && !super.equals(obj)) {
          return false;
        }
        
    if (getClass() != obj.getClass()) {
      if (!(obj instanceof DirektkandidaturTK)) {
        return false;
      }

      if (!obj.getClass().isInstance(this)) {
        return obj.equals(this); // equals-Methode aus speziellerer Klasse verwenden
      }

    }

        DirektkandidaturTK other = (DirektkandidaturTK) obj;

        
                if (direktkandidatTK == null) {
          if (other.direktkandidatTK != null) {
            return false;
          }
        } else if (!direktkandidatTK.equals(other.direktkandidatTK)) {
          return false;
        }
            return true;
    
  }

  protected boolean hatAttribute() {
        return true;
      }

  @Override
  public String getEntityMessageKey() {
    return DirektkandidaturConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getAllEntityFieldValues() {
    java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

    result.addAll(super.getAllEntityFieldValues());
    result.addAll(getEntityFieldValuesForEntity());
    result.addAll(direktkandidatTK.getAllEntityFieldValues());
    return result;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getEntityFieldValuesForEntity() {
            return java.util.Collections.emptyList();
      }


            @Override
            public String toString() {
            return "DirektkandidaturTK[" + toStringParameter() + "]";
            }



            protected String toStringParameter() {
            String result = ""

                                                    +"direktkandidatTK="+direktkandidatTK
            
            ;
                            String resultParent = super.toStringParameter();
                if (resultParent.isEmpty()) {
                return result;
                }
                if (result.isEmpty()) {
                return resultParent;
                }
                return resultParent +", " + result;
            
            }


      @Override       protected String toStringLokalisiertFields(IMessages messages) {
        return ""
                                                  +  toStringLokalisiert(direktkandidatTK, messages)
                                      + super.toStringLokalisiertFields(messages)
                     ;
      }


            private String toStringLokalisiert(de.ivu.elect.jee.entity.tk.EntityTK entityTK, IMessages messages) {
                if (entityTK != null) {
                    return entityTK.toStringLokalisiert(messages);
                }
                return null;
            }

            public static <E extends Direktkandidatur> java.util.Map<DirektkandidaturTK, E> mappeDirektkandidaturNachTK(java.util.Collection<E> entities) {
                return entities.stream().collect(java.util.stream.Collectors.toMap(Direktkandidatur::getDirektkandidaturTK, Function.<E>identity(), (u,v)-> v));
                }


                public static Function<Direktkandidatur, DirektkandidaturTK> getDirektkandidaturToTKFunction() {
                return Direktkandidatur::getDirektkandidaturTK;
                }

}
